--Tomatekh

print ("This is the 'Bridge Add/Remove Road' mod script.")

local pBridge = GameInfoTypes.IMPROVEMENT_PONTOON_BRIDGE_MOD;
local pRoad = GameInfoTypes.ROUTE_ROAD;

GameEvents.BuildFinished.Add(function(iPlayer, x, y, eImprovement) 
	local pPlayer = Players[iPlayer];
	local iPlot = Map.GetPlot(x, y);
	if (eImprovement == pBridge) then
		iPlot:SetRouteType(pRoad);
	end
end);

local tOcean = GameInfoTypes.TERRAIN_OCEAN;
local tCoast = GameInfoTypes.TERRAIN_COAST;

GameEvents.PlayerDoTurn.Add(
function(iPlayer)
    local pPlayer = Players[iPlayer];
    if (pPlayer:IsAlive()) then
		for pCity in pPlayer:Cities() do
			local pCityPlot = pCity:Plot()
			local plotX = pCityPlot:GetX();
			local plotY = pCityPlot:GetY();
			local iRange = 4;
			for iDX = -iRange, iRange do
				for iDY = -iRange, iRange do
					local pTargetPlot = Map.PlotXYWithRangeCheck(plotX, plotY, iDX, iDY, iRange);
					if pTargetPlot then
						if (pTargetPlot:GetTerrainType() == tCoast) or (pTargetPlot:GetTerrainType() == tOcean) then
							if (pTargetPlot:IsRoute()) and not (pTargetPlot:GetImprovementType() == pBridge) then
								pTargetPlot:SetRouteType(-1);
							end
						end
					end
				end
			end
		end
	end
end)

print ("This is the 'Bridge Land Attack Penalty' mod script.")

local pNavalPenalty = GameInfoTypes.PROMOTION_NAVAL_PENALTY;

GameEvents.PlayerDoTurn.Add(
function(iPlayer)
	for mPlayer=0, GameDefines.MAX_MAJOR_CIVS-1 do
		local mPlayer = Players[mPlayer];
		if (mPlayer:IsAlive()) then
			for pUnit in mPlayer:Units() do
				if pUnit:IsHasPromotion(pNavalPenalty) then
					pUnit:SetHasPromotion(pNavalPenalty,false);
				end
				if (pUnit:GetDomainType() == DomainTypes.DOMAIN_LAND) and not (pUnit:IsEmbarked()) then 
					local uPlot = pUnit:GetPlot();
					if (uPlot:GetImprovementType() == pBridge) then
						pUnit:SetHasPromotion(pNavalPenalty,true);
					end
				end
			end
		end
	end
end)